<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Transitional//EN" "https://www.w3.org/TR/xhtml1/DTD/xhtml1-transitional.dtd">
<html xmlns="http://www.w3.org/1999/xhtml">
<head>
<meta http-equiv="Content-Type" content="text/xhtml;charset=UTF-8"/>
<meta http-equiv="X-UA-Compatible" content="IE=9"/>
<meta name="generator" content="Doxygen 1.8.16"/>
<meta name="viewport" content="width=device-width, initial-scale=1"/>
<title>Zonzay: structural_svm_problem_abstract.h Source File</title>
<link href="tabs.css" rel="stylesheet" type="text/css"/>
<script type="text/javascript" src="jquery.js"></script>
<script type="text/javascript" src="dynsections.js"></script>
<link href="search/search.css" rel="stylesheet" type="text/css"/>
<script type="text/javascript" src="search/searchdata.js"></script>
<script type="text/javascript" src="search/search.js"></script>
<link href="doxygen.css" rel="stylesheet" type="text/css" />
</head>
<body>
<div id="top"><!-- do not remove this div, it is closed by doxygen! -->
<div id="titlearea">
<table cellspacing="0" cellpadding="0">
 <tbody>
 <tr style="height: 56px;">
  <td id="projectlogo"><img alt="Logo" src="zonzay.png"/></td>
  <td id="projectalign" style="padding-left: 0.5em;">
   <div id="projectname">Zonzay
   &#160;<span id="projectnumber">1</span>
   </div>
   <div id="projectbrief">Laugh game challenge</div>
  </td>
 </tr>
 </tbody>
</table>
</div>
<!-- end header part -->
<!-- Generated by Doxygen 1.8.16 -->
<script type="text/javascript">
/* @license magnet:?xt=urn:btih:cf05388f2679ee054f2beb29a391d25f4e673ac3&amp;dn=gpl-2.0.txt GPL-v2 */
var searchBox = new SearchBox("searchBox", "search",false,'Search');
/* @license-end */
</script>
<script type="text/javascript" src="menudata.js"></script>
<script type="text/javascript" src="menu.js"></script>
<script type="text/javascript">
/* @license magnet:?xt=urn:btih:cf05388f2679ee054f2beb29a391d25f4e673ac3&amp;dn=gpl-2.0.txt GPL-v2 */
$(function() {
  initMenu('',true,false,'search.php','Search');
  $(document).ready(function() { init_search(); });
});
/* @license-end */</script>
<div id="main-nav"></div>
<!-- window showing the filter options -->
<div id="MSearchSelectWindow"
     onmouseover="return searchBox.OnSearchSelectShow()"
     onmouseout="return searchBox.OnSearchSelectHide()"
     onkeydown="return searchBox.OnSearchSelectKey(event)">
</div>

<!-- iframe showing the search results (closed by default) -->
<div id="MSearchResultsWindow">
<iframe src="javascript:void(0)" frameborder="0" 
        name="MSearchResults" id="MSearchResults">
</iframe>
</div>

<div id="nav-path" class="navpath">
  <ul>
<li class="navelem"><a class="el" href="dir_f6486992fdfcc735347cc2d407578037.html">FaceFilterSDK</a></li><li class="navelem"><a class="el" href="dir_80a4fd4d67846ee877317f9ddd7282cb.html">DlibWrapper</a></li><li class="navelem"><a class="el" href="dir_9b7b8713e4f43f3006d0cb3c779d469e.html">dlib</a></li><li class="navelem"><a class="el" href="dir_5e84fc1d53d6c0d63218f3bf54f21eee.html">svm</a></li>  </ul>
</div>
</div><!-- top -->
<div class="header">
  <div class="headertitle">
<div class="title">structural_svm_problem_abstract.h</div>  </div>
</div><!--header-->
<div class="contents">
<div class="fragment"><div class="line"><a name="l00001"></a><span class="lineno">    1</span>&#160;<span class="comment">// Copyright (C) 2011  Davis E. King (davis@dlib.net)</span></div><div class="line"><a name="l00002"></a><span class="lineno">    2</span>&#160;<span class="comment">// License: Boost Software License   See LICENSE.txt for the full license.</span></div><div class="line"><a name="l00003"></a><span class="lineno">    3</span>&#160;<span class="preprocessor">#undef DLIB_STRUCTURAL_SVM_PRObLEM_ABSTRACT_Hh_</span></div><div class="line"><a name="l00004"></a><span class="lineno">    4</span>&#160;<span class="preprocessor">#ifdef DLIB_STRUCTURAL_SVM_PRObLEM_ABSTRACT_Hh_</span></div><div class="line"><a name="l00005"></a><span class="lineno">    5</span>&#160; </div><div class="line"><a name="l00006"></a><span class="lineno">    6</span>&#160;<span class="preprocessor">#include &quot;../optimization/optimization_oca_abstract.h&quot;</span></div><div class="line"><a name="l00007"></a><span class="lineno">    7</span>&#160;<span class="preprocessor">#include &quot;sparse_vector_abstract.h&quot;</span></div><div class="line"><a name="l00008"></a><span class="lineno">    8</span>&#160;<span class="preprocessor">#include &quot;../matrix.h&quot;</span></div><div class="line"><a name="l00009"></a><span class="lineno">    9</span>&#160; </div><div class="line"><a name="l00010"></a><span class="lineno">   10</span>&#160;<span class="keyword">namespace </span><a class="code" href="namespacedlib.html">dlib</a></div><div class="line"><a name="l00011"></a><span class="lineno">   11</span>&#160;{</div><div class="line"><a name="l00012"></a><span class="lineno">   12</span>&#160; </div><div class="line"><a name="l00013"></a><span class="lineno">   13</span>&#160;<span class="comment">// ----------------------------------------------------------------------------------------</span></div><div class="line"><a name="l00014"></a><span class="lineno">   14</span>&#160; </div><div class="line"><a name="l00015"></a><span class="lineno">   15</span>&#160;    <span class="keyword">template</span> &lt;</div><div class="line"><a name="l00016"></a><span class="lineno">   16</span>&#160;        <span class="keyword">typename</span> matrix_type_,</div><div class="line"><a name="l00017"></a><span class="lineno">   17</span>&#160;        <span class="keyword">typename</span> feature_vector_type_ = matrix_type_</div><div class="line"><a name="l00018"></a><span class="lineno">   18</span>&#160;        &gt;</div><div class="line"><a name="l00019"></a><span class="lineno">   19</span>&#160;    <span class="keyword">class </span>structural_svm_problem : <span class="keyword">public</span> oca_problem&lt;matrix_type_&gt; </div><div class="line"><a name="l00020"></a><span class="lineno">   20</span>&#160;    {</div><div class="line"><a name="l00021"></a><span class="lineno">   21</span>&#160;    <span class="keyword">public</span>:</div><div class="line"><a name="l00094"></a><span class="lineno">   94</span>&#160;        <span class="keyword">typedef</span> matrix_type_ <a class="code" href="classdlib_1_1structural__svm__problem.html#a838a31de24d3c3ea3f751c7db337b60f">matrix_type</a>;</div><div class="line"><a name="l00095"></a><span class="lineno">   95</span>&#160;        <span class="keyword">typedef</span> <span class="keyword">typename</span> matrix_type::type scalar_type;</div><div class="line"><a name="l00096"></a><span class="lineno">   96</span>&#160;        <span class="keyword">typedef</span> feature_vector_type_ feature_vector_type;</div><div class="line"><a name="l00097"></a><span class="lineno">   97</span>&#160; </div><div class="line"><a name="l00098"></a><span class="lineno">   98</span>&#160;        structural_svm_problem (</div><div class="line"><a name="l00099"></a><span class="lineno">   99</span>&#160;        );</div><div class="line"><a name="l00105"></a><span class="lineno">  105</span>&#160;        <span class="keywordtype">void</span> set_epsilon (</div><div class="line"><a name="l00106"></a><span class="lineno">  106</span>&#160;            scalar_type eps</div><div class="line"><a name="l00107"></a><span class="lineno">  107</span>&#160;        );</div><div class="line"><a name="l00115"></a><span class="lineno">  115</span>&#160;        <span class="keyword">const</span> scalar_type get_epsilon (</div><div class="line"><a name="l00116"></a><span class="lineno">  116</span>&#160;        ) <span class="keyword">const</span>;</div><div class="line"><a name="l00130"></a><span class="lineno">  130</span>&#160;        scalar_type get_cache_based_epsilon (</div><div class="line"><a name="l00131"></a><span class="lineno">  131</span>&#160;        ) <span class="keyword">const</span>;</div><div class="line"><a name="l00155"></a><span class="lineno">  155</span>&#160;        <span class="keywordtype">void</span> set_cache_based_epsilon (</div><div class="line"><a name="l00156"></a><span class="lineno">  156</span>&#160;            scalar_type eps</div><div class="line"><a name="l00157"></a><span class="lineno">  157</span>&#160;        );</div><div class="line"><a name="l00165"></a><span class="lineno">  165</span>&#160;        <span class="keywordtype">void</span> set_max_iterations (</div><div class="line"><a name="l00166"></a><span class="lineno">  166</span>&#160;            <span class="keywordtype">unsigned</span> <span class="keywordtype">long</span> max_iter</div><div class="line"><a name="l00167"></a><span class="lineno">  167</span>&#160;        );</div><div class="line"><a name="l00173"></a><span class="lineno">  173</span>&#160;        <span class="keywordtype">unsigned</span> <span class="keywordtype">long</span> get_max_iterations (</div><div class="line"><a name="l00174"></a><span class="lineno">  174</span>&#160;        ); </div><div class="line"><a name="l00181"></a><span class="lineno">  181</span>&#160;        <span class="keywordtype">void</span> set_max_cache_size (</div><div class="line"><a name="l00182"></a><span class="lineno">  182</span>&#160;            <span class="keywordtype">unsigned</span> <span class="keywordtype">long</span> max_size</div><div class="line"><a name="l00183"></a><span class="lineno">  183</span>&#160;        );</div><div class="line"><a name="l00189"></a><span class="lineno">  189</span>&#160;        <span class="keywordtype">unsigned</span> <span class="keywordtype">long</span> get_max_cache_size (</div><div class="line"><a name="l00190"></a><span class="lineno">  190</span>&#160;        ) <span class="keyword">const</span>; </div><div class="line"><a name="l00200"></a><span class="lineno">  200</span>&#160;        <span class="keywordtype">void</span> add_nuclear_norm_regularizer (</div><div class="line"><a name="l00201"></a><span class="lineno">  201</span>&#160;            <span class="keywordtype">long</span> first_dimension,</div><div class="line"><a name="l00202"></a><span class="lineno">  202</span>&#160;            <span class="keywordtype">long</span> rows,</div><div class="line"><a name="l00203"></a><span class="lineno">  203</span>&#160;            <span class="keywordtype">long</span> cols,</div><div class="line"><a name="l00204"></a><span class="lineno">  204</span>&#160;            <span class="keywordtype">double</span> regularization_strength</div><div class="line"><a name="l00205"></a><span class="lineno">  205</span>&#160;        );</div><div class="line"><a name="l00228"></a><span class="lineno">  228</span>&#160;        <span class="keywordtype">unsigned</span> <span class="keywordtype">long</span> num_nuclear_norm_regularizers (</div><div class="line"><a name="l00229"></a><span class="lineno">  229</span>&#160;        ) <span class="keyword">const</span>; </div><div class="line"><a name="l00239"></a><span class="lineno">  239</span>&#160;        <span class="keywordtype">void</span> clear_nuclear_norm_regularizers (</div><div class="line"><a name="l00240"></a><span class="lineno">  240</span>&#160;        );</div><div class="line"><a name="l00246"></a><span class="lineno">  246</span>&#160;        <span class="keywordtype">void</span> be_verbose (</div><div class="line"><a name="l00247"></a><span class="lineno">  247</span>&#160;        );</div><div class="line"><a name="l00254"></a><span class="lineno">  254</span>&#160;        <span class="keywordtype">void</span> be_quiet(</div><div class="line"><a name="l00255"></a><span class="lineno">  255</span>&#160;        );</div><div class="line"><a name="l00261"></a><span class="lineno">  261</span>&#160;        scalar_type get_c (</div><div class="line"><a name="l00262"></a><span class="lineno">  262</span>&#160;        ) <span class="keyword">const</span>; </div><div class="line"><a name="l00273"></a><span class="lineno">  273</span>&#160;        <span class="keywordtype">void</span> set_c (</div><div class="line"><a name="l00274"></a><span class="lineno">  274</span>&#160;            scalar_type C</div><div class="line"><a name="l00275"></a><span class="lineno">  275</span>&#160;        );</div><div class="line"><a name="l00283"></a><span class="lineno">  283</span>&#160;    <span class="comment">// --------------------------------</span></div><div class="line"><a name="l00284"></a><span class="lineno">  284</span>&#160;    <span class="comment">//     User supplied routines</span></div><div class="line"><a name="l00285"></a><span class="lineno">  285</span>&#160;    <span class="comment">// --------------------------------</span></div><div class="line"><a name="l00286"></a><span class="lineno">  286</span>&#160; </div><div class="line"><a name="l00287"></a><span class="lineno">  287</span>&#160;        <span class="keyword">virtual</span> <span class="keywordtype">long</span> get_num_dimensions (</div><div class="line"><a name="l00288"></a><span class="lineno">  288</span>&#160;        ) <span class="keyword">const</span> = 0;</div><div class="line"><a name="l00294"></a><span class="lineno">  294</span>&#160;        <span class="keyword">virtual</span> <span class="keywordtype">long</span> get_num_samples (</div><div class="line"><a name="l00295"></a><span class="lineno">  295</span>&#160;        ) <span class="keyword">const</span> = 0;</div><div class="line"><a name="l00301"></a><span class="lineno">  301</span>&#160;        <span class="keyword">virtual</span> <span class="keywordtype">void</span> get_truth_joint_feature_vector (</div><div class="line"><a name="l00302"></a><span class="lineno">  302</span>&#160;            <span class="keywordtype">long</span> idx,</div><div class="line"><a name="l00303"></a><span class="lineno">  303</span>&#160;            feature_vector_type&amp; psi </div><div class="line"><a name="l00304"></a><span class="lineno">  304</span>&#160;        ) <span class="keyword">const</span> = 0;</div><div class="line"><a name="l00313"></a><span class="lineno">  313</span>&#160;        <span class="keyword">virtual</span> <span class="keywordtype">void</span> separation_oracle (</div><div class="line"><a name="l00314"></a><span class="lineno">  314</span>&#160;            <span class="keyword">const</span> <span class="keywordtype">long</span> idx,</div><div class="line"><a name="l00315"></a><span class="lineno">  315</span>&#160;            <span class="keyword">const</span> <a class="code" href="classdlib_1_1structural__svm__problem.html#a838a31de24d3c3ea3f751c7db337b60f">matrix_type</a>&amp; current_solution,</div><div class="line"><a name="l00316"></a><span class="lineno">  316</span>&#160;            scalar_type&amp; loss,</div><div class="line"><a name="l00317"></a><span class="lineno">  317</span>&#160;            feature_vector_type&amp; psi</div><div class="line"><a name="l00318"></a><span class="lineno">  318</span>&#160;        ) <span class="keyword">const</span> = 0;</div><div class="line"><a name="l00340"></a><span class="lineno">  340</span>&#160;    };</div><div class="line"><a name="l00341"></a><span class="lineno">  341</span>&#160; </div><div class="line"><a name="l00342"></a><span class="lineno">  342</span>&#160;<span class="comment">// ----------------------------------------------------------------------------------------</span></div><div class="line"><a name="l00343"></a><span class="lineno">  343</span>&#160; </div><div class="line"><a name="l00344"></a><span class="lineno">  344</span>&#160;}</div><div class="line"><a name="l00345"></a><span class="lineno">  345</span>&#160; </div><div class="line"><a name="l00346"></a><span class="lineno">  346</span>&#160;<span class="preprocessor">#endif // DLIB_STRUCTURAL_SVM_PRObLEM_ABSTRACT_Hh_</span></div><div class="line"><a name="l00347"></a><span class="lineno">  347</span>&#160; </div><div class="line"><a name="l00348"></a><span class="lineno">  348</span>&#160; </div></div><!-- fragment --></div><!-- contents -->
<div class="ttc" id="aclassdlib_1_1structural__svm__problem_html_a838a31de24d3c3ea3f751c7db337b60f"><div class="ttname"><a href="classdlib_1_1structural__svm__problem.html#a838a31de24d3c3ea3f751c7db337b60f">dlib::structural_svm_problem::matrix_type</a></div><div class="ttdeci">matrix_type_ matrix_type</div><div class="ttdef"><b>Definition:</b> structural_svm_problem.h:255</div></div>
<div class="ttc" id="anamespacedlib_html"><div class="ttname"><a href="namespacedlib.html">dlib</a></div><div class="ttdef"><b>Definition:</b> algs.h:119</div></div>
<!-- start footer part -->
<hr class="footer"/><address class="footer"><small>
Generated by &#160;<a href="http://www.doxygen.org/index.html">
<img class="footer" src="doxygen.png" alt="doxygen"/>
</a> 1.8.16
</small></address>
</body>
</html>
